"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _LocalizedCredential_bundle;
Object.defineProperty(exports, "__esModule", { value: true });
const LocalizedAttribute_1 = __importDefault(require("./LocalizedAttribute"));
class LocalizedCredential {
    constructor(bundle, record, language) {
        _LocalizedCredential_bundle.set(this, void 0);
        if (!language) {
            throw new Error('language is required');
        }
        __classPrivateFieldSet(this, _LocalizedCredential_bundle, bundle, "f");
        this.issuer = bundle.metadata.issuer?.[language];
        this.name = bundle.metadata.name?.[language];
        this.watermark = bundle.metadata?.watermark?.[language];
        this.attributes = (record.credentialAttributes ?? []).map((attribute) => new LocalizedAttribute_1.default(attribute, bundle.getAttribute(attribute.name) ?? { name: attribute.name, type: '' }, language));
    }
    get primaryAttribute() {
        const name = __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.primaryAttribute;
        return this.getAttribute(name);
    }
    get secondaryAttribute() {
        const name = __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.secondaryAttribute;
        return this.getAttribute(name);
    }
    get logo() {
        return __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.logo;
    }
    get primaryBackgroundColor() {
        return __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.primaryBackgroundColor;
    }
    get secondaryBackgroundColor() {
        return __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.secondaryBackgroundColor;
    }
    get backgroundImage() {
        return __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.backgroundImage;
    }
    get backgroundImageSlice() {
        return __classPrivateFieldGet(this, _LocalizedCredential_bundle, "f").branding?.backgroundImageSlice;
    }
    getAttribute(attributeName) {
        if (!attributeName) {
            return undefined;
        }
        return this.attributes.find((attribute) => attribute.name === attributeName);
    }
}
_LocalizedCredential_bundle = new WeakMap();
exports.default = LocalizedCredential;
