import { AnonCredsNonRevokedInterval, AnonCredsProofRequestRestriction } from '@credo-ts/anoncreds';
export interface FieldParams {
    name: string | null;
    format?: string;
    type?: string;
    encoding?: string;
    mimeType?: string;
    revoked?: boolean;
    credentialId?: string;
    label?: string;
    restrictions?: AnonCredsProofRequestRestriction[];
    nonRevoked?: AnonCredsNonRevokedInterval;
}
export interface AttributeParams extends FieldParams {
    value: string | number | null;
    revealed?: boolean;
}
export interface PredicateParams extends FieldParams {
    pValue: string | number | null;
    pType: string;
    parameterizable?: boolean;
    satisfied?: boolean;
}
export declare class Field {
    name: string | null;
    format?: string;
    type?: string;
    encoding?: string;
    mimeType?: string;
    revoked?: boolean;
    credentialId?: string;
    label?: string;
    restrictions?: AnonCredsProofRequestRestriction[];
    nonRevoked?: AnonCredsNonRevokedInterval;
    protected constructor(params: FieldParams);
}
export declare class Attribute extends Field {
    value: string | number | null;
    revealed?: boolean;
    constructor(params: AttributeParams);
}
export declare class Predicate extends Field {
    pValue: string | number | null;
    pType: string;
    parameterizable?: boolean;
    satisfied?: boolean;
    constructor(params: PredicateParams);
}
