"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const BrandingOverlay_1 = __importDefault(require("./branding/BrandingOverlay"));
const LegacyBrandingOverlay_1 = __importDefault(require("./branding/LegacyBrandingOverlay"));
const CharacterEncodingOverlay_1 = __importDefault(require("./semantic/CharacterEncodingOverlay"));
const FormatOverlay_1 = __importDefault(require("./semantic/FormatOverlay"));
const InformationOverlay_1 = __importDefault(require("./semantic/InformationOverlay"));
const LabelOverlay_1 = __importDefault(require("./semantic/LabelOverlay"));
const MetaOverlay_1 = __importDefault(require("./semantic/MetaOverlay"));
const StandardOverlay_1 = __importDefault(require("./semantic/StandardOverlay"));
const OverlayTypeMap = new Map(Object.entries({
    'spec/overlays/character_encoding/1.0': CharacterEncodingOverlay_1.default,
    'spec/overlays/label/1.0': LabelOverlay_1.default,
    'spec/overlays/information/1.0': InformationOverlay_1.default,
    'spec/overlays/format/1.0': FormatOverlay_1.default,
    'spec/overlays/standard/1.0': StandardOverlay_1.default,
    'spec/overlays/meta/1.0': MetaOverlay_1.default,
    'aries/overlays/branding/1.0': BrandingOverlay_1.default,
    'aries/overlays/branding/0.1': LegacyBrandingOverlay_1.default,
}));
exports.default = OverlayTypeMap;
