"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Secondary = void 0;
const react_native_1 = require("react-native");
const Secondary = ({ source, style, tint = false }) => {
    const { width, height, backgroundColor, zIndex } = style ?? {};
    const borderRadius = 10;
    const styles = react_native_1.StyleSheet.create({
        container: {
            width,
            minHeight: height,
            borderTopLeftRadius: borderRadius,
            borderBottomLeftRadius: borderRadius,
            backgroundColor,
            zIndex,
        },
        tintContainer: {
            backgroundColor: 'rgba(0,0,0,0.24)',
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            zIndex: 1,
        },
        image: {
            flex: 1,
        },
    });
    return (<react_native_1.View 
    // testID={testIdWithKey('CredentialCardSecondaryBody')}
    style={styles.container}>
      <react_native_1.View style={tint ? styles.tintContainer : null}/>
      {source && (<react_native_1.ImageBackground source={source} style={styles.image} imageStyle={{
                borderTopLeftRadius: borderRadius,
                borderBottomLeftRadius: borderRadius,
            }}/>)}
    </react_native_1.View>);
};
exports.Secondary = Secondary;
exports.default = exports.Secondary;
