"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const lodash_startcase_1 = __importDefault(require("lodash.startcase"));
const react_native_1 = require("react-native");
const credentialTheme_1 = require("../../../contexts/credentialTheme");
const Label = ({ label, textStyle }) => {
    const { color } = textStyle ?? {};
    const { text } = (0, credentialTheme_1.useCredentialTheme)();
    const styles = react_native_1.StyleSheet.create({
        container: {
            marginTop: 15,
            color,
            flexShrink: 1,
        },
    });
    return (<react_native_1.Text style={[
            text.labelNormal,
            styles.container,
            {
                lineHeight: 19,
                opacity: 0.8,
            },
        ]}>
      {label ?? (0, lodash_startcase_1.default)(label)}
    </react_native_1.Text>);
};
exports.default = Label;
