"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const utils_1 = require("../../../../utils");
const credentialTheme_1 = require("../../../contexts/credentialTheme");
const borderRadius = 10;
const Value = ({ value, textStyle }) => {
    const { color } = textStyle ?? {};
    const { text } = (0, credentialTheme_1.useCredentialTheme)();
    const styles = react_native_1.StyleSheet.create({
        container: {
            color,
            flexShrink: 1,
        },
        image: {
            height: 150,
            aspectRatio: 1,
            resizeMode: 'contain',
            borderRadius,
        },
    });
    return (<react_native_1.View>
      {(0, utils_1.isDataUrl)(value) ? (<react_native_1.Image style={styles.image} source={{ uri: value }}></react_native_1.Image>) : (<react_native_1.Text style={[
                text.bold,
                styles.container,
                {
                    lineHeight: 24,
                },
            ]}>
          {value}
        </react_native_1.Text>)}
    </react_native_1.View>);
};
exports.default = Value;
