"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const utils_1 = require("../../../utils");
const credentialTheme_1 = require("../../contexts/credentialTheme");
const Logo = ({ source, label = 'Credential', elevation = 0, style }) => {
    const { text } = (0, credentialTheme_1.useCredentialTheme)();
    const { width, height, position, top, left } = style ?? {};
    const borderRadius = 10;
    const styles = react_native_1.StyleSheet.create({
        container: {
            width,
            height,
            position,
            top,
            left,
            borderRadius,
            backgroundColor: '#ffffff',
            justifyContent: 'center',
            alignItems: 'center',
            shadowColor: '#000',
            shadowOffset: {
                width: 1,
                height: 1,
            },
            shadowOpacity: 0.3,
            zIndex: 2,
        },
        image: {
            width,
            height,
            resizeMode: 'cover',
            borderRadius: 8,
        },
        text: {
            fontSize: 0.5 * width,
            alignSelf: 'center',
            color: '#000',
        },
    });
    return (<react_native_1.View style={[styles.container, { elevation }]}>
      {source ? (<react_native_1.Image source={(0, utils_1.toImageSource)(source)} style={styles.image}/>) : (<react_native_1.Text style={[text.bold, styles.text]}>{label.charAt(0).toUpperCase()}</react_native_1.Text>)}
    </react_native_1.View>);
};
exports.default = Logo;
