"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const Watermark = ({ watermark = '', textStyle, style }) => {
    const { fontSize } = textStyle ?? {};
    const { width, height } = style ?? {};
    const styles = react_native_1.StyleSheet.create({
        container: {
            width,
            height,
            position: 'absolute',
            top: -0.33 * height,
            left: -0.05 * width - 5,
        },
        text: {
            opacity: 0.16,
            transform: [{ rotate: '-30deg' }],
            overflow: 'visible',
        },
    });
    const rows = [...Array(Math.ceil(height / fontSize + 1)).keys()];
    const text = `${watermark} `.repeat(Math.ceil(width / (Math.cos(30) * ((fontSize / 2) * (watermark.length + 1)))));
    return (<react_native_1.View style={styles.container}>
      {rows.map((i) => (<react_native_1.Text accessible={false} key={i} numberOfLines={1} style={[styles.text, { fontSize }, textStyle]}>
          {text}
        </react_native_1.Text>))}
    </react_native_1.View>);
};
exports.default = Watermark;
