"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const Detail_1 = __importDefault(require("../../../ui/components/detail/Detail"));
const localizedCredential_1 = require("../../contexts/localizedCredential");
const react_i18next_1 = require("react-i18next");
const i18n_1 = require("../../../ui/i18n");
const CredentialDetail = ({ i18n }) => {
    const localizedCredential = (0, localizedCredential_1.useLocalizedCredential)();
    if (!i18n) {
        i18n = (0, i18n_1.initi18n)();
    }
    return (<react_i18next_1.I18nextProvider i18n={i18n}>
      <Detail_1.default credential={localizedCredential}/>
    </react_i18next_1.I18nextProvider>);
};
exports.default = CredentialDetail;
