"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const contexts_1 = require("../../../../ui/contexts");
const react_i18next_1 = require("react-i18next");
const react_native_1 = require("react-native");
const constants_1 = require("../../../components/detail/constants");
const ToggleAll = ({ toggled = false, onToggleAll = () => false }) => {
    const { t } = (0, react_i18next_1.useTranslation)();
    const { color, text } = (0, contexts_1.useCredentialTheme)();
    const styles = react_native_1.StyleSheet.create({
        container: {
            flexDirection: 'row',
            justifyContent: 'flex-end',
            marginHorizontal: constants_1.PADDING_HORIZONTAL,
            paddingVertical: constants_1.PADDING_VERTICAL,
        },
        link: {
            paddingVertical: 2,
        },
        linkText: {
            color: color.brand.link,
        },
    });
    const toggle = () => {
        onToggleAll(!toggled);
    };
    return (<react_native_1.View style={styles.container}>
      <react_native_1.Pressable 
    // testID={testIdWithKey('ToggleAll')}
    style={({ pressed }) => [styles.link, { opacity: +!pressed }]} onPress={() => toggle()} accessible={true} accessibilityLabel={toggled ? t('Detail.HideAll') : t('Detail.ShowAll')}>
        <react_native_1.Text style={[text.labelNormal, styles.linkText]}>{toggled ? t('Detail.HideAll') : t('Detail.ShowAll')}</react_native_1.Text>
      </react_native_1.Pressable>
    </react_native_1.View>);
};
exports.default = ToggleAll;
