"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_native_1 = require("react-native");
const Secondary = ({ source, style, tint = false }) => {
    const { height, backgroundColor, zIndex } = style ?? {};
    const styles = react_native_1.StyleSheet.create({
        container: {
            minHeight: height,
            backgroundColor,
            zIndex,
        },
        tintContainer: {
            backgroundColor: 'rgba(0,0,0,0.24)',
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            zIndex: 1,
        },
        image: {
            flex: 1,
        },
    });
    return (<react_native_1.View 
    // testID={testIdWithKey('CredentialDetailsSecondaryHeader')}
    style={styles.container}>
      <react_native_1.View style={tint ? styles.tintContainer : null}/>
      {source && <react_native_1.ImageBackground source={source} style={styles.image} imageStyle={{ resizeMode: 'cover' }}/>}
    </react_native_1.View>);
};
exports.default = Secondary;
