"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStyleSheet = void 0;
const react_native_1 = require("react-native");
const utils_1 = require("../../components/common/utils");
const constants_1 = require("./constants");
const createStyleSheet = (windowWidth) => {
    const baseStyles = (0, utils_1.createBaseStyleSheet)(windowWidth);
    const secondaryHeight = constants_1.MAX_HEIGHT * 1.5;
    const styles = react_native_1.StyleSheet.create({
        ...baseStyles,
        logo: {
            ...baseStyles.logo,
            width: constants_1.MAX_HEIGHT,
            height: constants_1.MAX_HEIGHT,
            top: constants_1.MAX_HEIGHT,
            left: constants_1.PADDING_HORIZONTAL,
        },
        secondary: {
            height: secondaryHeight,
        },
        primary: {},
        primaryChild: {
            paddingHorizontal: constants_1.PADDING_HORIZONTAL,
            paddingVertical: constants_1.PADDING_VERTICAL,
        },
        issuerText: {
            paddingLeft: constants_1.MAX_HEIGHT + constants_1.PADDING_VERTICAL,
        },
        nameText: {
            paddingTop: constants_1.PADDING_VERTICAL,
        },
        status: {
            ...baseStyles.status,
            width: constants_1.MAX_HEIGHT,
            height: constants_1.MAX_HEIGHT,
        },
    });
    return styles;
};
exports.createStyleSheet = createStyleSheet;
