"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCredentialTheme = exports.CredentialThemeContext = void 0;
const react_1 = require("react");
var GrayscaleColors;
(function (GrayscaleColors) {
    GrayscaleColors["BLACK"] = "#000000";
    GrayscaleColors["DARK_GREY"] = "#313132";
    GrayscaleColors["MEDIUM_GREY"] = "#606060";
    GrayscaleColors["LIGHT_GREY"] = "#D3D3D3";
    GrayscaleColors["VERY_LIGHT_GREY"] = "#F2F2F2";
    GrayscaleColors["WHITE"] = "#FFFFFF";
})(GrayscaleColors || (GrayscaleColors = {}));
var NotificationColors;
(function (NotificationColors) {
    NotificationColors["WARN"] = "#313132";
    // ERROR = '#313132',
})(NotificationColors || (NotificationColors = {}));
var SemanticColors;
(function (SemanticColors) {
    SemanticColors["WARN"] = "#FCBA19";
    SemanticColors["ERROR"] = "#D8292F";
})(SemanticColors || (SemanticColors = {}));
const color = {
    brand: {
        link: GrayscaleColors.DARK_GREY,
        text: GrayscaleColors.DARK_GREY,
        background: GrayscaleColors.VERY_LIGHT_GREY,
    },
    grayscale: {
        black: GrayscaleColors.BLACK,
        darkGrey: GrayscaleColors.DARK_GREY,
        mediumGrey: GrayscaleColors.MEDIUM_GREY,
        lightGrey: GrayscaleColors.LIGHT_GREY,
        veryLightGrey: GrayscaleColors.VERY_LIGHT_GREY,
        white: GrayscaleColors.WHITE,
    },
    notification: {
        warn: NotificationColors.WARN,
        error: NotificationColors.WARN,
    },
    semantic: {
        warn: SemanticColors.WARN,
        error: SemanticColors.ERROR,
    },
};
const text = {
    normal: {
        fontSize: 18,
        fontWeight: 'normal',
        color: color.brand.text,
    },
    bold: {
        fontSize: 18,
        fontWeight: 'bold',
        color: color.brand.text,
    },
    labelNormal: {
        fontSize: 14,
        fontWeight: 'normal',
        color: color.brand.text,
    },
    labelBold: {
        fontSize: 14,
        fontWeight: 'bold',
        color: color.brand.text,
    },
};
exports.CredentialThemeContext = (0, react_1.createContext)({
    color,
    text,
});
const useCredentialTheme = () => (0, react_1.useContext)(exports.CredentialThemeContext);
exports.useCredentialTheme = useCredentialTheme;
