"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const mulberry32_1 = __importDefault(require("./mulberry32"));
/**
 * Converts a numerical hash into a hexidecimal color string
 * @see https://helderesteves.com/generating-random-colors-js/#Generating_random_dark_colors
 * @param { number } hash numerical hash value (generated by hashCode function above)
 * @returns { string } hexidecimal string eg. #32d3cc
 */
const hashToRGBA = (hash) => {
    let color = '#';
    const colorRangeUpperBound = 256;
    // once for r, g, b
    for (let i = 0; i < 3; i++) {
        // append a pseudorandom two-char hexidecimal value from the lower half of the color spectrum (to limit to darker colors)
        color += ('0' + Math.floor(((0, mulberry32_1.default)(hash + i) * colorRangeUpperBound) / 2).toString(16)).slice(-2);
    }
    return color;
};
exports.default = hashToRGBA;
