import { IOverlayBundleData } from '@oca/interfaces';
import { OverlayBundle } from '@oca/types';
export interface CredentialIdentifiers {
    schemaId?: string;
    credentialDefinitionId?: string;
    templateId?: string;
}
export interface CredentialMetaData {
    credentialId?: string;
    credentialAlias?: string;
    connectionId?: string;
    connectionAlias?: string;
}
export interface OverlayBundleResolverOptions {
    language?: string;
}
export interface OverlayBundleResolverType {
    resolveBundle(params: {
        identifiers: CredentialIdentifiers;
    }): Promise<OverlayBundle | undefined>;
    resolveDefaultBundle(params: {
        identifiers: CredentialIdentifiers;
        metadata?: CredentialMetaData;
        language?: string;
    }): Promise<OverlayBundle | undefined>;
}
export declare class BaseOverlayBundleResolver {
    private _log?;
    /**
     * Get the log value.
     */
    get log(): any;
    /**
     * Sets the log value.
     * @param value - The new value for the log.
     */
    set log(value: any);
}
export declare class OverlayBundleResolver extends BaseOverlayBundleResolver implements OverlayBundleResolverType {
    protected bundles: Record<string, OverlayBundle | string>;
    constructor(bundles?: Record<string, IOverlayBundleData | string>);
    private getDefaultBundle;
    resolveDefaultBundle(params: {
        identifiers: CredentialIdentifiers;
        metadata?: CredentialMetaData;
        language?: string;
    }): Promise<OverlayBundle | undefined>;
    resolveBundle(params: {
        identifiers: CredentialIdentifiers;
    }): Promise<OverlayBundle | undefined>;
}
