import { View, ImageBackground, StyleSheet } from 'react-native';
export const Secondary = ({ source, style, tint = false }) => {
    const { width, height, backgroundColor, zIndex } = style ?? {};
    const borderRadius = 10;
    const styles = StyleSheet.create({
        container: {
            width,
            minHeight: height,
            borderTopLeftRadius: borderRadius,
            borderBottomLeftRadius: borderRadius,
            backgroundColor,
            zIndex,
        },
        tintContainer: {
            backgroundColor: 'rgba(0,0,0,0.24)',
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            zIndex: 1,
        },
        image: {
            flex: 1,
        },
    });
    return (<View 
    // testID={testIdWithKey('CredentialCardSecondaryBody')}
    style={styles.container}>
      <View style={tint ? styles.tintContainer : null}/>
      {source && (<ImageBackground source={source} style={styles.image} imageStyle={{
                borderTopLeftRadius: borderRadius,
                borderBottomLeftRadius: borderRadius,
            }}/>)}
    </View>);
};
export default Secondary;
