import startCase from 'lodash.startcase';
import { Text, StyleSheet } from 'react-native';
import { useCredentialTheme } from '../../../contexts/credentialTheme';
const Label = ({ label, textStyle }) => {
    const { color } = textStyle ?? {};
    const { text } = useCredentialTheme();
    const styles = StyleSheet.create({
        container: {
            marginTop: 15,
            color,
            flexShrink: 1,
        },
    });
    return (<Text style={[
            text.labelNormal,
            styles.container,
            {
                lineHeight: 19,
                opacity: 0.8,
            },
        ]}>
      {label ?? startCase(label)}
    </Text>);
};
export default Label;
