import { View, Image, Text, StyleSheet } from 'react-native';
import { isDataUrl } from '../../../../utils';
import { useCredentialTheme } from '../../../contexts/credentialTheme';
const borderRadius = 10;
const Value = ({ value, textStyle }) => {
    const { color } = textStyle ?? {};
    const { text } = useCredentialTheme();
    const styles = StyleSheet.create({
        container: {
            color,
            flexShrink: 1,
        },
        image: {
            height: 150,
            aspectRatio: 1,
            resizeMode: 'contain',
            borderRadius,
        },
    });
    return (<View>
      {isDataUrl(value) ? (<Image style={styles.image} source={{ uri: value }}></Image>) : (<Text style={[
                text.bold,
                styles.container,
                {
                    lineHeight: 24,
                },
            ]}>
          {value}
        </Text>)}
    </View>);
};
export default Value;
