import { View, StyleSheet, Text } from 'react-native';
const Watermark = ({ watermark = '', textStyle, style }) => {
    const { fontSize } = textStyle ?? {};
    const { width, height } = style ?? {};
    const styles = StyleSheet.create({
        container: {
            width,
            height,
            position: 'absolute',
            top: -0.33 * height,
            left: -0.05 * width - 5,
        },
        text: {
            opacity: 0.16,
            transform: [{ rotate: '-30deg' }],
            overflow: 'visible',
        },
    });
    const rows = [...Array(Math.ceil(height / fontSize + 1)).keys()];
    const text = `${watermark} `.repeat(Math.ceil(width / (Math.cos(30) * ((fontSize / 2) * (watermark.length + 1)))));
    return (<View style={styles.container}>
      {rows.map((i) => (<Text accessible={false} key={i} numberOfLines={1} style={[styles.text, { fontSize }, textStyle]}>
          {text}
        </Text>))}
    </View>);
};
export default Watermark;
