import Detail from '../../../ui/components/detail/Detail';
import { useLocalizedCredential } from '../../contexts/localizedCredential';
import { I18nextProvider } from 'react-i18next';
import { initi18n } from '../../../ui/i18n';
const CredentialDetail = ({ i18n }) => {
    const localizedCredential = useLocalizedCredential();
    if (!i18n) {
        i18n = initi18n();
    }
    return (<I18nextProvider i18n={i18n}>
      <Detail credential={localizedCredential}/>
    </I18nextProvider>);
};
export default CredentialDetail;
