import { ImageBackground, StyleSheet, View } from 'react-native';
const Secondary = ({ source, style, tint = false }) => {
    const { height, backgroundColor, zIndex } = style ?? {};
    const styles = StyleSheet.create({
        container: {
            minHeight: height,
            backgroundColor,
            zIndex,
        },
        tintContainer: {
            backgroundColor: 'rgba(0,0,0,0.24)',
            position: 'absolute',
            top: 0,
            left: 0,
            right: 0,
            bottom: 0,
            zIndex: 1,
        },
        image: {
            flex: 1,
        },
    });
    return (<View 
    // testID={testIdWithKey('CredentialDetailsSecondaryHeader')}
    style={styles.container}>
      <View style={tint ? styles.tintContainer : null}/>
      {source && <ImageBackground source={source} style={styles.image} imageStyle={{ resizeMode: 'cover' }}/>}
    </View>);
};
export default Secondary;
