interface Spectrum {
    black: string;
    darkGrey: string;
    mediumGrey: string;
    lightGrey: string;
    veryLightGrey: string;
    white: string;
}
/**
 * Returns the color that contrasts the most with the given color.
 * @param color The color to contrast.
 * @param shadeDark The color to return if the given color is light.
 * @param shadeLight The color to return if the given color is dark.
 * @param spectrum The color spectrum to use if the shades are not provided.
 * @returns The contrasting color. Defaults to black and white.
 */
export declare const contrastColor: (color?: string, shadeDark?: string, shadeLight?: string, spectrum?: Spectrum) => string;
export default contrastColor;
